node {
   def mvnHome
   def scannerHome
   stage('Preparation') { // for display purposes
      // Get some code from a GitHub repository
      checkout([$class: 'GitSCM', branches: [[name: '*/master']], doGenerateSubmoduleConfigurations: false, extensions: [], submoduleCfg: [],   userRemoteConfigs: [[credentialsId: '39850114-ac3d-4047-8916-36d5df248153', url: 'https://gitlab.com/sekar.logic/myfirstproject-java.git']]])
      // Get the Maven tool.
      // ** NOTE: This 'M3' Maven tool must be configured
      // **       in the global configuration.           
      mvnHome = tool 'MAVEN_HOME'
	   scannerHome = tool 'SonarScanner'
   }
   stage('CompileandPackage') {
      // Run the maven build
      withEnv(["MVN_HOME=$mvnHome"]) {
         if (isUnix()) {
            sh '"$MVN_HOME/bin/mvn" -Dmaven.test.failure.ignore clean package'
         } else {
            bat(/"%MVN_HOME%\bin\mvn" -Dmaven.test.failure.ignore clean package/)
         }
      }
   }
   stage('CodeAnalysis') {        
      withSonarQubeEnv("SonarCloud") {
                     sh "${tool("SonarScanner")}/bin/sonar-scanner"
                  }
            }
   stage('DeploytoTomcat') {
      deploy adapters: [tomcat8(credentialsId: 'baa3dd09-536d-4d5b-b84c-e99a26f37147', path: '', url: 'http://localhost:8080')], contextPath: 'spring-project', war: '**/*.war'
   } 
   stage('FunctionalTesting') {
      sleep 60
	  sh label: '', script: 'mvn -Dfilename=testng-functional.xml surefire:test'
   }  
}
